<?php

##########################################
##		<id>M-DVD:topicsfilter</id>		##
##		<name>Topics Filter</name>		##
##		<version>3.1</version>			##
##		<type>modification</type>		##
##########################################

/******************************************************************************
* This program is free software; you may redistribute it and/or modify it     *
* under the terms of the provided license as published by SMF.                *

* This program is distributed in the hope that it is and will be useful,      *
* but WITHOUT ANY WARRANTIES; without even any implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                        *
******************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

function topic_filter($version)
{
	global $modSettings, $user_info, $context, $txt, $settings;

	$filter_types = array('date0', 'date1', 'replies', 'pages', 'letter', 'icon');
//	$filter_nosaved = array('letter' => 'letter', 'icon' => 'icon');
	$filter = array();
	$filter_temp = array (
		'letter' => array('All', '#', '0-9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'),
		'date' => array(0, 1, 2, 7, 30, 60, 90, 180, 270, 365, 366),
		'replies' => array('none', 'nore', 'hot', 'very', 'poll', 'lock'),
		'pages' => array($modSettings['defaultMaxTopics'], 10, 20, 30, 40, 50),
		'icon' => empty($modSettings['topicsfilter_icon']) ? '' : (1 == $version ? topic_icons_fil_1() : topic_icons_fil_2()),
	);

	// What Filters are enable?
	foreach ($filter_types as $type)
	{
		if (empty($modSettings['topicsfilter_' . $type]))
		{
			$user_info['filter_topic'][$type] = '';
			continue;
		}

		// Fill Var
		$filter[$type] = 'date0' == $type || 'date1' == $type ? $filter_temp['date'] : $filter_temp[$type];
		$filter_type = 'filter_' . $type;

		// Ajustments
		$user_info['filter_topic'][$type] = empty($user_info['filter_topic'][$type]) ? 0 : $user_info['filter_topic'][$type];
//		if (in_array($type, $filter_nosaved))
//			$user_info['filter_topic'][$type] = isset($_GET[$filter_type]) ? $_GET[$filter_type] : 0;
		if ('replies' == $type)
			if ($context['user']['is_logged']) $filter['replies'][] = 'own';
			else array_pop($txt['filter_replies_values']);

		// Reset This Variable?
		if (isset($_GET['filter_reset']))
			$_GET[$filter_type] = 0;

		// Processing GET
		if (isset($_GET[$filter_type]))
		{
			// Validating the Request
			if (!isset($filter[$type][$_GET[$filter_type]]))
				$_GET[$filter_type] = 0;

			// If have change then will save the data
//				if ($_GET[$filter_type] != $user_info['filter_topic'][$type] && !in_array($type, $filter_nosaved))
			if ($_GET[$filter_type] != $user_info['filter_topic'][$type])
				$filter_topic_saved = true;

			$user_info['filter_topic'][$type] = (int)$_GET[$filter_type];
		}
	}

	// if is necesary, save the data
	if (!empty($filter_topic_saved))
	{
//		$serialize = array_diff(array_diff_key($user_info['filter_topic'], $filter_nosaved), array('', '0'));
		$serialize = array_diff($user_info['filter_topic'], array('', '0'));
		$serialize = empty($serialize) ? '' : serialize($serialize);

		if ($context['user']['is_logged'])
			updateMemberData($context['user']['id'], array('filter_topic' => ($version < 2) ? '\''.$serialize.'\'' : $serialize));
		else
			$_SESSION['filter_topic'] = $serialize;
	}

	## Creating Filters Querys
	$filter_querys = array();

	// Fields by SMF version
	$fields = (1 == $version)
				? array('ptime' => 'posterTime', 'numre' => 'numReplies', 'idpol' => 'ID_POLL', 'idmem' => 'ID_MEMBER_STARTED')
				: array('ptime' => 'poster_time', 'numre' => 'num_replies', 'idpol' => 'id_poll', 'idmem' => 'id_member_started');

	foreach ($filter_types as $key)
		if (!empty($user_info['filter_topic'][$key]))
		{
			// Filter Pages
			if ('pages' == $key)
				$modSettings['defaultMaxTopics'] = $filter['pages'][$user_info['filter_topic'][$key]];

			// Filter Date
			if ('date0' == $key || 'date1' == $key)
				$filter_querys[$key] = 'AND ' . (time() - 86400 *
				(10 == $user_info['filter_topic'][$key] ? 365 : $filter[$key][$user_info['filter_topic'][$key]])) .
				(10 == $user_info['filter_topic'][$key] ? ' > ' : ' <= ') . ('date0' == $key ? 'mf.' : 'ml.') . $fields['ptime'];

			// Filter Replies
			if ('replies' == $key)
			{
				$topicsfilter = array(
					'nore'	=> 'AND t.'. $fields['numre'] . ' = 0',
					'hot'	=> 'AND t.'. $fields['numre'] . ' >= ' . $modSettings['hotTopicPosts'] . ' AND t.'. $fields['numre'] . ' < ' .$modSettings['hotTopicVeryPosts'],
					'very'	=> 'AND t.'. $fields['numre'] . ' >= ' . $modSettings['hotTopicVeryPosts'],
					'poll'	=> 'AND t.'. $fields['idpol'] . ' != 0',
					'lock'	=> 'AND t.locked != 0',
					'own'	=> 'AND t.'. $fields['idmem'] . ' = '. $context['user']['id']
				);

				$filter_querys[$key] = $topicsfilter[$filter['replies'][$user_info['filter_topic'][$key]]];
			}

			// Filter Letter
			if ('letter' == $key)
				$filter_querys[$key] =
						($user_info['filter_topic'][$key] == 1
							? 'AND mf.subject NOT REGEXP(\'^[0-9a-zA-Z]\')'
							: ($user_info['filter_topic'][$key] == 2
								? 'AND mf.subject REGEXP(\'^[0-9]\')'
								: 'AND mf.subject LIKE \''. $filter['letter'][$user_info['filter_topic'][$key]] . '%\'')
						);

			// Filter Pages
			if ('icon' == $key)
				$filter_querys[$key] = empty($user_info['filter_topic'][$key]) ? '' : 'AND mf.icon = \'' . $filter['icon'][$user_info['filter_topic'][$key]] . '\'';
		}

	## Set the Filters Javascript Variables
	$context['html_headers'] .= '
	<script language="JavaScript" type="text/javascript" src="' . $settings['default_theme_url'] . '/topics_filter.js?tfv31"></script>
	<script language="JavaScript" type="text/javascript"><!-- // --><![CDATA[
		var oTopicsFilter = new TopicsFilter({
			iBoardId: ' . $context['current_board'] . ',
			sSortby: "' . (empty($_REQUEST['sort']) ? '' : 'sort=' . $_REQUEST['sort'] . (isset($_REQUEST['desc']) ? ';desc' : '')) . '",';

	if (!empty($modSettings['topicsfilter_sortby']))
		$context['html_headers'] .= '
			aSortTopicsBy: new Array("sort", "' . (empty($_REQUEST['sort']) ? 'last_post;desc' : $_REQUEST['sort'] . (isset($_REQUEST['desc']) ? ';desc' : '')) . '", "' . $txt['filter_sort_title'] . '",  Array("' . implode('", "', $txt['filter_sort_values']) . '")),';

	foreach ($filter as $key => $value)
		$context['html_headers'] .= '
			aFilter' . ucfirst($key) . ': new Array("' . $key . '", ' . $user_info['filter_topic'][$key] . ', "' . $txt['filter_' . $key . '_title'] . '", ' . ('letter' == $key ? 'LettersPreload("' . $txt['filter_letter_values'][0] : ' Array("' . implode('", "', $txt['filter_' . ('date0' == $key || 'date1' == $key ? 'date' : $key) . '_values'])) . '")),';

	$context['html_headers'] .= '
			sReset: "' . $txt['filter_Reset'] . '"
		});
	// ]]></script>';

	// Tidy up
	unset($filter, $filter_types, $filter_temp, $filter_nosaved, $topicsfilter);

	return $filter_querys;
}

#### Message Icons Filter ####
function topic_icons_fil_1()
{
	global $db_prefix, $txt;

	$values = array('');

	$result = db_query("SELECT filename, title FROM {$db_prefix}message_icons ORDER BY ID_ICON ASC", __FILE__, __LINE__);

	while ($row = mysql_fetch_assoc($result))
	{
		$values[] = $row['filename'];
		$txt['filter_icon_values'][] = $row['title'];
	}
	mysql_free_result($result);

	$txt['filter_icon_values'] = array_merge($txt['filter_icon_values'], $txt['filter_icon_values_end']);

	return array_merge($values, array('moved', 'recycled', 'wireless', 'clip'));
}

function topic_icons_fil_2()
{
	global $smcFunc, $txt;

	$values = array('');

	$result = $smcFunc['db_query']('', 'SELECT filename, title FROM {db_prefix}message_icons ORDER BY id_icon ASC', array());

	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$values[] = $row['filename'];
		$txt['filter_icon_values'][] = $row['title'];
	}
	$smcFunc['db_free_result']($result);

	$txt['filter_icon_values'] = array_merge($txt['filter_icon_values'], $txt['filter_icon_values_end']);

	return array_merge($values, array('moved', 'recycled', 'wireless', 'clip'));
}

?>